<html>
<head>
<title>OgreWindowEventUtilities.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreWindowEventUtilities.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreWindowEventUtilities_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreWindowEventUtils_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreWindowEventUtils_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#  define WIN32_LEAN_AND_MEAN</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#  if !defined(NOMINMAX) &amp;&amp; defined(_MSC_VER)</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#   define NOMINMAX // required to stop windows.h messing up std::min</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#  endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;windows.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE &amp;&amp; !defined(__LP64__)</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;Carbon/Carbon.h&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">namespace </span>Ogre
<a name="l00047"></a>00047 {
<a name="l00058"></a><a class="code" href="classOgre_1_1WindowEventListener.html">00058</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a>
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060     <span class="keyword">public</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1WindowEventListener.html#a908a45e8cf9e3c5f35988abed57b12da">00061</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1WindowEventListener.html#a908a45e8cf9e3c5f35988abed57b12da">~WindowEventListener</a>() {}
<a name="l00062"></a>00062 
<a name="l00069"></a><a class="code" href="classOgre_1_1WindowEventListener.html#abf7a3cb2023860d55367c9ed337d386c">00069</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowMoved(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)
<a name="l00070"></a>00070                 { (void)rw; }
<a name="l00071"></a>00071 
<a name="l00078"></a><a class="code" href="classOgre_1_1WindowEventListener.html#a87d8fa99072dfdb5d3b0b26a7cfd0120">00078</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowResized(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)
<a name="l00079"></a>00079                 { (void)rw; }
<a name="l00080"></a>00080 
<a name="l00088"></a><a class="code" href="classOgre_1_1WindowEventListener.html#af9fa93b6ae8284d7ba3d20c329edab82">00088</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> windowClosing(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)
<a name="l00089"></a>00089         { (void)rw; <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00090"></a>00090 
<a name="l00101"></a><a class="code" href="classOgre_1_1WindowEventListener.html#ad18f2f48f1d6f501b05ffd9e9a782590">00101</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowClosed(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)
<a name="l00102"></a>00102                 { (void)rw; }
<a name="l00103"></a>00103 
<a name="l00110"></a><a class="code" href="classOgre_1_1WindowEventListener.html#a8a1cf8cba40a4b84db339ccb02c0bf3c">00110</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> windowFocusChange(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* rw)
<a name="l00111"></a>00111                 { (void)rw; }
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113 
<a name="l00118"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html">00118</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html">WindowEventUtilities</a>
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120     <span class="keyword">public</span>:
<a name="l00126"></a>00126         <span class="keyword">static</span> <span class="keywordtype">void</span> messagePump();
<a name="l00127"></a>00127 
<a name="l00138"></a>00138         <span class="keyword">static</span> <span class="keywordtype">void</span> addWindowEventListener( <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window, <a class="code" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a>* listener );
<a name="l00139"></a>00139 
<a name="l00148"></a>00148         <span class="keyword">static</span> <span class="keywordtype">void</span> removeWindowEventListener( <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window, <a class="code" href="classOgre_1_1WindowEventListener.html">WindowEventListener</a>* listener );
<a name="l00149"></a>00149 
<a name="l00157"></a>00157         <span class="keyword">static</span> <span class="keywordtype">void</span> _addRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window);
<a name="l00158"></a>00158 
<a name="l00166"></a>00166         <span class="keyword">static</span> <span class="keywordtype">void</span> _removeRenderWindow(<a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* window);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>
<a name="l00170"></a>00170         <span class="keyword">static</span> LRESULT CALLBACK _WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
<a name="l00171"></a>00171 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE &amp;&amp; !defined __OBJC__ &amp;&amp; !defined(__LP64__)</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>
<a name="l00173"></a>00173         <span class="keyword">static</span> OSStatus _CarbonWindowHandler(EventHandlerCallRef nextHandler, EventRef event, <span class="keywordtype">void</span>* wnd);
<a name="l00174"></a>00174 <span class="preprocessor">#endif</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>
<a name="l00176"></a>00176         <span class="comment">//These are public only so GLXProc can access them without adding Xlib headers header</span>
<a name="l00177"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#aafdcf922139191ea16619f5ac6da2627">00177</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html#abbc044dc966133fc43888a7c8cad6237">multimap&lt;RenderWindow*, WindowEventListener*&gt;::type</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html#aafdcf922139191ea16619f5ac6da2627">WindowEventListeners</a>;
<a name="l00178"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#a482ccdb9b1bbdc5439c622399ff4b0b9">00178</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1WindowEventUtilities.html#aafdcf922139191ea16619f5ac6da2627">WindowEventListeners</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html#a482ccdb9b1bbdc5439c622399ff4b0b9">_msListeners</a>;
<a name="l00179"></a>00179 
<a name="l00180"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#a75753b8587c1b0de1dd271545a317e93">00180</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;RenderWindow*&gt;::type</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html#a75753b8587c1b0de1dd271545a317e93">Windows</a>;
<a name="l00181"></a><a class="code" href="classOgre_1_1WindowEventUtilities.html#a930c740afae53b8336150b4b9794c96f">00181</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1WindowEventUtilities.html#a75753b8587c1b0de1dd271545a317e93">Windows</a> <a class="code" href="classOgre_1_1WindowEventUtilities.html#a930c740afae53b8336150b4b9794c96f">_msWindows</a>;
<a name="l00182"></a>00182     };
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
